//+------------------------------------------------------------------+ 
//|                                  TrendStrength jurik channel.mq4 | 
//|                                                                  | 
//|                                         http://www.forextsd.com  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window 
#property indicator_buffers    4 
#property indicator_color1     DarkOrange
#property indicator_width1     2
#property indicator_color2     White
#property indicator_style2     STYLE_DASH
#property indicator_color3     Red
#property indicator_width3     1
#property indicator_color4     LimeGreen
#property indicator_width4     1
#property indicator_level1     0
#property indicator_levelcolor Violet

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = 0;
extern int    OmaLength        = 2;
extern double OmaSpeed         = 8.0;
extern bool   OmaAdaptive      = true;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;
extern bool   Interpolate      = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern string  __              = "arrows settings";
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "oma trendstrength arrows1";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Orange;


//
//
//
//
//

double ts[];
double zz[];
double hb[];
double lb[];
double zzlow[];
double zzhigh[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(7);  
     SetIndexBuffer(0,ts); SetIndexLabel(0,"TS"); 
     SetIndexBuffer(1,zz); SetIndexLabel(1, NULL);  SetIndexStyle(1,DRAW_SECTION);       
     SetIndexBuffer(2,hb);
     SetIndexBuffer(3,lb);
     SetIndexBuffer(4,zzlow);
     SetIndexBuffer(5,zzhigh);
     SetIndexBuffer(6,trend);
   
     SetIndexEmptyValue(0,0);
     SetIndexEmptyValue(1,0);
     SetIndexEmptyValue(4,0);
     SetIndexEmptyValue(5,0);
   
     if (ShowChannel)
     {
     SetIndexStyle(2,DRAW_LINE);
     SetIndexStyle(3,DRAW_LINE);
     }
     else      
     {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
     }
   
     //
     //
     //
     //
     //
   
       OmaSpeed          = MathMax(OmaSpeed,-1.5);
       OmaLength         = MathMax(OmaLength,1);
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame) +  " Oma TrendStrength channel"); 
   
return(0); 
} 

//
//
//
//
//

int deinit(){  if (!calculateValue && ShowArrows) deleteArrows();  return(0); } 

//
//
//
//
//

int start() 
{  
   int counted_bars=IndicatorCounted();
   int lastZag;
   int i,r,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
          if (returnBars) { ts[0] = MathMin(limit+1,Bars-1); return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {     
      
       if (ShowZigZag)
       for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;

       //
       //
       //
       //
       //
       
       for(i=limit, r=Bars-i-1; i>=0; i--, r++)
       {
              double       tmp = iMA(NULL,0, 5,0, MODE_EMA,PRICE_CLOSE,i);     
              double ma1 = tmp - iMA(NULL,0,10,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma2 = tmp - iMA(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma3 = tmp - iMA(NULL,0,30,0,MODE_SMMA,PRICE_CLOSE,i); 
              double ma4 = tmp - iMA(NULL,0,40,0,MODE_SMMA,PRICE_CLOSE,i);  
              double ma5 = tmp - iMA(NULL,0,50,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma6 = tmp - iMA(NULL,0,60,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma7 = tmp - iMA(NULL,0,70,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma8 = tmp - iMA(NULL,0,80,0,MODE_SMMA,PRICE_CLOSE,i);
              double ma9 = tmp - iMA(NULL,0,90,0,MODE_SMMA,PRICE_CLOSE,i);         
         
              ts[i] = iAverage((ma1+ma2+ma3+ma4+ma5+ma6+ma7+ma8+ma9)/9,OmaLength,OmaSpeed,OmaAdaptive,r,0);
              lb[i] = ts[ArrayMinimum(ts,HighLowPeriod,i)];
              hb[i] = ts[ArrayMaximum(ts,HighLowPeriod,i)];
          
              //
              //
              //
              //
              //
   
              trend[i] = trend[i+1];
              if (ts[i] > lb[i] && ts[i+1] <= lb[i+1]) trend[i] =  1;  
              if (ts[i] < hb[i] && ts[i+1] >= hb[i+1]) trend[i] = -1;
              if (!calculateValue) manageArrow(i);
              
   //
   //
   //
   //
   //
   
   if (!ShowZigZag) continue;
      
              zzlow[i]  = 0;
              zzhigh[i] = 0;
              
              if (lb[i] < lb[i+1])
              {
                  if (zz[lastZag] == lb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  lb[i];
                      zzlow[i]    =  lb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (hb[i] > hb[i+1])
              {
                  if (zz[lastZag] == hb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  hb[i];
                      zzhigh[i]   =  hb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (zz[i] != 0)
              {
                  zz[i] = 0;
                  for (lastZag=i+1; lastZag<Bars; lastZag++)
                  {
                     if (zzlow[lastZag]  != 0) { zz[lastZag] = zzlow[lastZag];  break; }
                     if (zzhigh[lastZag] != 0) { zz[lastZag] = zzhigh[lastZag]; break; }
                  }
                  
              }
    
          }
            
        manageAlerts();
         
    return(0); 
    }
    
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    
    if (ShowZigZag)
    for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
    
    for (i=limit;i>=0; i--)
    {
        int y = iBarShift(NULL,timeFrame,Time[i]);
            ts[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
            zz[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
            hb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
            lb[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
            zzlow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
            zzhigh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
            trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,OmaLength,OmaSpeed,OmaAdaptive,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
            
            manageArrow(i); 
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  ts[i+k] = ts[i] + (ts[i+n] - ts[i]) * k/n;
                  hb[i+k] = hb[i] + (hb[i+n] - hb[i]) * k/n;
                  lb[i+k] = lb[i] + (lb[i+n] - lb[i]) * k/n;

            //
            //
            //
            //
            //
               
            }  	            
   }
      
   manageAlerts();
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double stored[][7];

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,221,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,222,true );
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 2.0*iATR(NULL,0,20,i)/4.0;//3.0*
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Oma TrendStrength trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Oma TrendStrength "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

